## gcin 2.8.2+dfsg1

=== Makefile ===
OPTFLAGS=-g

include config.mak
include suffixes-rule

gcin_tsin_o = tsin.o tsin-util.o win0.o win1.o tsin-parse.o
gcin_pho_o = win-pho.o pho.o pho-util.o pho-sym.o table-update.o pho-dbg.o
gcin_gtab_o = gtab.o win-gtab.o gtab-util.o gtab-list.o gtab-buf.o

GCIN_SO= gcin1.so gcin2.so

OBJS=gcin.o eve.o util.o gcin-conf.o gcin-settings.o locale.o gcin-icon.o about.o html-browser.o \
     gcin-exec-script.o $(GCIN_SO) pho-play.o cache.o gtk_bug_fix.o phrase-save-menu.o \
     $(gcin_pho_o) $(gcin_gtab_o) gcin-common.o phrase.o t2s-lookup.o gtab-use-count.o \
     win-save-phrase.o unix-exec.o pho-kbm-name.o statistic.o tsin-scan.o gcin-module.o lang.o \
     gcin-module-cb.o gtab-init.o fullchar.o gtab-tsin-fname.o win-screen-status.o


OBJS_TSLEARN=tslearn.o util.o gcin-conf.o pho-util.o tsin-util.o gcin-send.o pho-sym.o \
             table-update.o locale.o gcin-settings.o gcin-common.o gcin-icon.o pho-dbg.o  \
             pho2pinyin.o pinyin.o lang.o gtab-list.o gtab-init.o fullchar.o \
             gtab-tsin-fname.o unix-exec.o gtab-util.o

OBJS_TS_EDIT=ts-edit.o util.o gcin-conf.o pho-util.o tsin-util.o gcin-send.o pho-sym.o \
             table-update.o locale.o gcin-settings.o gcin-common.o gcin-icon.o pho-dbg.o  \
             pho2pinyin.o pinyin.o lang.o gtab-list.o gtab-init.o fullchar.o \
             gtab-tsin-fname.o unix-exec.o gtab-util.o ts-upload.o ts-download.o

OBJS_JUYIN_LEARN=juyin-learn.o locale.o util.o pho-util.o pho-sym.o pho2pinyin.o \
                 gcin-settings.o gcin-conf.o table-update.o pinyin.o gcin-icon.o pho-dbg.o
OBJS_sim2trad=sim2trad.o util.o gcin2.so locale.o gcin-conf.o gcin-icon.o
OBJS_phod2a=phod2a.o pho-util.o gcin-conf.o pho-sym.o table-update.o pho-dbg.o locale.o \
             gcin-settings.o util.o
OBJS_tsa2d32=tsa2d32.o gcin-send.o util.o pho-sym.o gcin-conf.o locale.o pho-lookup.o \
pinyin.o pho2pinyin.o pho-dbg.o gcin-settings.o lang.o
OBJS_phoa2d=phoa2d.o pho-sym.o gcin-send.o gcin-conf.o locale.o pho-lookup.o util.o pho-dbg.o
OBJS_kbmcv=kbmcv.o pho-sym.o util.o locale.o
OBJS_tsd2a32=tsd2a32.o pho-sym.o pho-dbg.o locale.o util.o gtab-dbg.o pho2pinyin.o \
	gcin-conf.o pinyin.o tsin-util.o lang.o unix-exec.o gcin-settings.o
OBJS_gcin2tab=gcin2tab.o gtab-util.o util.o locale.o
OBJS_gtab_merge=gtab-merge.o gtab-util.o util.o locale.o
OBJS_gcin_tools=gcin-tools.o gcin-conf.o util.o gcin-send.o gcin-settings.o html-browser.o \
	gcin-setup-list.o locale.o gcin-setup-pho.o about.o lang.o gcin-tools-appearance.o \
	gcin-icon.o gcin-setup-gtab.o gtab-list.o gcin-exec-script.o pho-kbm-name.o gcin-module-cb.o

OBJS_gcin_gb_toggle = gcin-gb-toggle.o gcin-conf.o util.o gcin-send.o
OBJS_gcin_kbm_toggle = gcin-kbm-toggle.o gcin-conf.o util.o gcin-send.o
OBJS_gcin_exit = gcin-exit.o gcin-conf.o util.o gcin-send.o
OBJS_gcin_message = gcin-message.o gcin-conf.o util.o gcin-send.o
OBJS_pin_juyin = pin-juyin.o util.o pho-lookup.o locale.o pho-sym.o

OBJS_tsin2gtab_phrase = tsin2gtab-phrase.o gcin-conf.o util.o locale.o \
	pho-dbg.o pho-sym.o gtab-dbg.o lang.o

OBJS_txt2gtab_phrase = txt2gtab-phrase.o gcin-conf.o util.o locale.o \
	pho-dbg.o pho-sym.o gtab-dbg.o lang.o

#WALL=-Wall

ifeq ($(USE_XIM),Y)
IMdkitLIB = IMdkit/lib/libXimd.a
CFLAGS += -DUSE_XIM=1
OBJS+=IC.o
endif

ifeq ($(USE_TRAY),Y)
CFLAGS += -DTRAY_ENABLED=1
OBJS += tray.o eggtrayicon.o tray-win32.o
endif

ifeq ($(USE_I18N),Y)
CFLAGS += -DGCIN_i18n_message=1
endif

ifeq ($(USE_TSIN),Y)
CFLAGS += -DUSE_TSIN=1
OBJS += $(gcin_tsin_o)
endif

ifeq ($(USE_GCB),Y)
CFLAGS += -DUSE_GCB=1
OBJS += gcb.o
endif

ifeq ($(USE_INDICATOR),Y)
CFLAGS += -DUSE_INDICATOR=1 $(INDICATOR_INC)
OBJS += tray-indicator.o
LDFLAGS += $(INDICATOR_LIB)
endif

OBJ_IMSRV=im-addr.o im-dispatch.o im-srv.o gcin-crypt.o

PROGS=gcin tsd2a32 tsa2d32 phoa2d phod2a tslearn gcin-tools gcin2tab \
	juyin-learn sim2trad gcin-gb-toggle gcin-message gtab-merge \
	gcin-kbm-toggle tsin2gtab-phrase gcin-exit ts-edit ts-contribute \
	txt2gtab-phrase
PROGS_SYM=trad2sim
PROGS_CV=kbmcv pin-juyin


all:	$(PROGS) trad2sim $(GCIN_SO) $(DATA) $(PROGS_CV) gcin.spec gcin-fedora.spec
	$(MAKE) -C data
	$(MAKE) -C gtk-im
	if [ $(BUILD_MODULE) = 'Y' ]; then $(MAKE) -C modules; fi
	if [ $(USE_I18N) = 'Y' ]; then $(MAKE) -C po; fi
	if [ $(GTK3_IM) = 'Y' ]; then $(MAKE) -C gtk3-im; fi
	if [ $(QT_IM) = 'Y' ]; then $(MAKE) -C qt-im; fi
	if [ $(QT4_IM) = 'Y' ]; then $(MAKE) -C qt4-im; fi

#gcc_ld_run_path=-Wl,-rpath,$(gcin_ld_run_path)

gcin:   $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV)
	$(CCLD) $(EXTRA_LDFLAGS) $(gcc_ld_run_path) -o $@ $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV) -lXtst $(LDFLAGS) -L/usr/X11R6/$(LIB)
	rm -f core.* vgcore.*
	ln -sf $@ $@.test

gcin-nocur:   $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV)
	$(CCLD) -Wl,-rpath,$(gcinlibdir) $(EXTRA_LDFLAGS) -o $@ $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV) -lXtst $(LDFLAGS) -L/usr/X11R6/$(LIB)
	rm -f core.*

tslearn:        $(OBJS_TSLEARN)
	$(CCLD) $(gcc_ld_run_path) -o $@ $(OBJS_TSLEARN) -L./im-client -lgcin-im-client $(LDFLAGS)

ts-edit:        $(OBJS_TS_EDIT)
	$(CCLD) $(gcc_ld_run_path) -o $@ $(OBJS_TS_EDIT) -L./im-client -lgcin-im-client $(LDFLAGS)

ts-contribute:	ts-edit
	ln -s $< $@

juyin-learn:        $(OBJS_JUYIN_LEARN)
	$(CCLD) -o $@ $(OBJS_JUYIN_LEARN) $(LDFLAGS)
	rm -f core.*
sim2trad:        $(OBJS_sim2trad)
	$(CC) $(gcc_ld_run_path) -o $@ $(OBJS_sim2trad) $(LDFLAGS)
	rm -f core.*
trad2sim:	sim2trad
	ln -sf sim2trad trad2sim

gcin-tools:     $(OBJS_gcin_tools) im-client/libgcin-im-client.so
	rm -f core.*
	$(CCLD) $(gcc_ld_run_path) -o $@ $(OBJS_gcin_tools) -L./im-client -lgcin-im-client $(LDFLAGS)

phoa2d: $(OBJS_phoa2d) im-client/libgcin-im-client.so
	$(CCLD) $(gcc_ld_run_path) -o $@ $(OBJS_phoa2d) -L./im-client -lgcin-im-client $(LDFLAGS)

phod2a: $(OBJS_phod2a)
	$(CCLD) -lX11 -o $@ $(OBJS_phod2a) $(LDFLAGS)

tsa2d32:  $(OBJS_tsa2d32) im-client/libgcin-im-client.so
	$(CCLD) $(gcc_ld_run_path) -o $@ $(OBJS_tsa2d32) -L./im-client -lgcin-im-client $(LDFLAGS)

tsd2a:  $(OBJS_tsd2a)
	$(CCLD) -o $@ $(OBJS_tsd2a) $(LDFLAGS)

tsd2a32:  $(OBJS_tsd2a32)
	$(CCLD) -o $@ $(OBJS_tsd2a32) $(LDFLAGS)

gcin2tab:  $(OBJS_gcin2tab)
	$(CCLD) -o $@ $(OBJS_gcin2tab) $(LDFLAGS)
	rm -f data/*.gtab

gtab-merge:  $(OBJS_gtab_merge)
	$(CCLD) -o $@ $(OBJS_gtab_merge) $(LDFLAGS)

kbmcv:  $(OBJS_kbmcv)
	$(CCLD) -o $@ $(OBJS_kbmcv) $(LDFLAGS)

gcin-gb-toggle:	$(OBJS_gcin_gb_toggle)
	$(CCLD) $(gcc_ld_run_path) -o $@ $(OBJS_gcin_gb_toggle) -L./im-client -lgcin-im-client $(LDFLAGS)

gcin-kbm-toggle:	$(OBJS_gcin_kbm_toggle)
	$(CCLD) $(gcc_ld_run_path) -o $@ $(OBJS_gcin_kbm_toggle) -L./im-client -lgcin-im-client $(LDFLAGS)

gcin-exit:	$(OBJS_gcin_exit)
	$(CCLD) $(gcc_ld_run_path) -o $@ $(OBJS_gcin_exit) -L./im-client -lgcin-im-client $(LDFLAGS)

gcin-message:	$(OBJS_gcin_message)
	$(CCLD) $(gcc_ld_run_path) -o $@ $(OBJS_gcin_message) -L./im-client -lgcin-im-client $(LDFLAGS)

pin-juyin:	$(OBJS_pin_juyin)
	$(CCLD) -o $@ $(OBJS_pin_juyin) $(LDFLAGS)

tsin2gtab-phrase:       $(OBJS_tsin2gtab_phrase)
	$(CCLD) -o $@ $(OBJS_tsin2gtab_phrase) $(LDFLAGS)

txt2gtab-phrase:       $(OBJS_txt2gtab_phrase)
	$(CCLD) -o $@ $(OBJS_txt2gtab_phrase) $(LDFLAGS)

im-client/libgcin-im-client.so:
	$(MAKE) -C im-client

gcin-version.h:	VERSION.gcin
	echo '#define GCIN_VERSION "'`cat VERSION.gcin`'"' > gcin-version.h

gcin1_so += win-message.pico win-sym.pico \
win-inmd-switch.pico pinyin.pico win-pho-near.pico win-kbm.pico gcin-module.pico pho2pinyin.pico

gcin1.so: $(gcin1_so) pho.o tsin.o eve.o gtab.o win-sym.o
	$(CCLD) $(SO_FLAGS) -o $@ $(gcin1_so) $(LDFLAGS)

gcin2_so= t2s-lookup.pico
gcin2.so: $(gcin2_so) gcin-conf.o
	$(CCLD) $(SO_FLAGS) -o $@ $(gcin2_so) $(LDFLAGS)

$(IMdkitLIB):
	$(MAKE) -C IMdkit/lib

ibin:	gcin-nocur
	install $(PROGS) $(bindir); \
	cp gcin-nocur $(bindir)/gcin; \
	rm -f $(bindir)/trad2sim; ln -sf sim2trad $(bindir)/trad2sim
	rm -f $(bindir)/ts-contribute; ln -sf ts-edit $(bindir)/ts-contribute
	install $(GCIN_SO) $(gcinlibdir)

icons_apps=$(datadir)/icons/hicolor/64x64/apps
install:
	install -d $(icons_apps)
	install -m 644 gcin.png $(icons_apps)
	$(MAKE) -C icons install
	install -d $(gcinlibdir)
	install $(GCIN_SO) $(gcinlibdir)
	install -d $(bindir)
	$(MAKE) -C data install
	$(MAKE) -C im-client install
	$(MAKE) -C gtk-im install
	if [ $(BUILD_MODULE) = 'Y' ]; then $(MAKE) -C modules install; fi
	if [ $(GTK3_IM) = 'Y' ]; then $(MAKE) -C gtk3-im install; fi
	if [ $(QT_IM) = 'Y' ]; then $(MAKE) -C qt-im install; fi
	if [ $(QT4_IM) = 'Y' ]; then $(MAKE) -C qt4-im install; fi
	if [ $(prefix) = /usr/local ]; then \
	   install -m 644 gcin.png /usr/share/icons/hicolor/64x64/apps; \
	   install -d $(DOC_DIR); \
	   install -m 644 README.html Changelog.html $(DOC_DIR); \
	   install $(PROGS) $(bindir); \
	   rm -f $(bindir)/trad2sim; ln -sf sim2trad $(bindir)/trad2sim; \
	   rm -f $(bindir)/ts-contribute; ln -sf ts-edit $(bindir)/ts-contribute; \
	   rm -f $(bindir)/ts-contribute-en; ln -sf ts-edit $(bindir)/ts-contribute-en; \
	   rm -f $(bindir)/ts-edit-en; ln -sf ts-edit $(bindir)/ts-edit-en; \
	else \
	   install -d $(DOC_DIR_i); \
	   install -m 644 README.html Changelog.html $(DOC_DIR_i); \
	   install -s $(PROGS) $(bindir); \
	   rm -f $(bindir)/trad2sim; ln -sf sim2trad $(bindir)/trad2sim; \
	   rm -f $(bindir)/ts-contribute; ln -sf ts-edit $(bindir)/ts-contribute; \
	   rm -f $(bindir)/ts-contribute-en; ln -sf ts-edit $(bindir)/ts-contribute-en; \
	   rm -f $(bindir)/ts-edit-en; ln -sf ts-edit $(bindir)/ts-edit-en; \
	fi
	$(MAKE) -C scripts install
	$(MAKE) -C menu install
	if [ $(USE_I18N) = 'Y' ]; then $(MAKE) -C po install; fi

clean:
	$(MAKE) -C IMdkit clean
	$(MAKE) -C data clean
	$(MAKE) -C scripts clean
	$(MAKE) -C im-client clean
	$(MAKE) -C gtk-im clean
	$(MAKE) -C modules clean
	if [ $(GTK3_IM) = 'Y' ]; then $(MAKE) -C gtk3-im clean; fi
	$(MAKE) -C qt-im clean
	$(MAKE) -C qt4-im clean
	$(MAKE) -C menu clean
	$(MAKE) -C po clean
	rm -fr *.o *.E *.db *.pico *.so config.mak tags $(PROGS) gcin-nocur $(PROGS_CV) \
	$(DATA) .depend gcin.spec trad2sim gcin.spec.tmp gcin.log
	find . '(' -name '.ted*' -o -name '*~' -o -name 'core*' -o -name 'vgcore.*' -o -name .depend ')' -exec rm {} \;

.depend:
	$(CCX) $(CFLAGS) -MM *.cpp > $@

config.mak: VERSION.gcin configure
	./configure

gcin.spec:	gcin.spec.in
	rm -f $@
	sed -e "s/__gcin_version__/$(GCIN_VERSION)/" < $< > $@

gcin-fedora.spec:	gcin-fedora.spec.in VERSION.gcin
	rm -f $@
	sed -e "s/__gcin_version__/$(GCIN_VERSION)/" < $< > $@

include .depend

=== data/Makefile ===
include ../config.mak

.SUFFIXES:	.kbmsrc .kbm .cin .gtab
CFLAGS= -DUNIX=1 $(WALL) $(OPTFLAGS) $(GTKINC) -I.. -DDEBUG="0$(GCIN_DEBUG)"
export NO_GTK_INIT=
export GCIN_NO_RELOAD=

DATA=pho.tab2 tsin32.idx NewCJ3.gtab \
     cj.gtab ar30.gtab ar30-big.gtab pinyin.gtab jyutping.gtab cj5.gtab \
     et.kbm et26.kbm zo.kbm pinyin.kbm dvorak.kbm mitac.kbm colemak.kbm \
     ibm.kbm tsin32 hsu.kbm pho-huge.tab2 simplex.gtab symbols.gtab russian.gtab \
     greek.gtab cj-punc.gtab latin-letters.gtab tsin-1.src pin-juyin.xlt \
     t2s.dat s2t.dat cj543.gtab s-tsin32 s-tsin32.idx s-pho.tab2 s-pho-huge.tab2 \
     pinyin-no-tone.kbm simplex-punc.gtab hangul.gtab ar33.gtab array-symbols.gtab \
     vims.gtab german.gtab array10a.gtab en-american en-american.idx pho-char.gtab

DATAKEEP=symbol-table gtab.list phrase.table phrase-ctrl.table hangul-phrase.txt

all:	$(DATA)

tsin32:	tsin.src ../tsa2d32
	export LD_LIBRARY_PATH=../im-client;../tsa2d32 $<
tsin32.idx:	tsin32

s-tsin32:	s-tsin.src ../tsa2d32
	export LD_LIBRARY_PATH=../im-client;../tsa2d32 $< $@
s-tsin32.idx:	s-tsin32

en-american:	en-american.src ../tsa2d32
	export LD_LIBRARY_PATH=../im-client;../tsa2d32 $<
en-american.idx:	en-american

pho.tab2:	 pho.tab2.src ../phoa2d
	export LD_LIBRARY_PATH=../im-client;../phoa2d $<

s-pho.tab2:	 s-pho.tab2.src ../phoa2d
	export LD_LIBRARY_PATH=../im-client;../phoa2d $<

pho-huge.tab2:	 pho-huge.tab2.src ../phoa2d
	export LD_LIBRARY_PATH=../im-client;../phoa2d $<

s-pho-huge.tab2:	 s-pho-huge.tab2.src ../phoa2d
	export LD_LIBRARY_PATH=../im-client;../phoa2d $<

t2s.dat:	t2s-file t2s-file.table
	./t2s-file
s2t.dat:	t2s-file

pin-juyin.xlt:	../pin-juyin pin-juyin.src
	../pin-juyin

extr1:	extr1.c
	$(CC) $(CFLAGS) $< ../util.o ../locale.o -o $@ $(LDFLAGS)

t2s-file:	t2s-file.c
	$(CC) $(CFLAGS) $< ../util.o ../locale.o -o $@ $(LDFLAGS)

tsin-1.src:	extr1
	./extr1 > $@

.cin.gtab:      ../gcin2tab
	../gcin2tab $<

.kbmsrc.kbm:	../kbmcv
	../kbmcv $<

install:
	install -d $(GCIN_TABLE_DIR_i)
	install -m 644 $(DATA) $(DATAKEEP) $(GCIN_TABLE_DIR_i)
#	cd $(GCIN_TABLE_DIR_i); bzip2 -f *.gtab
clean:
	rm -f *~ tags core.* $(DATA) *.gtab extr1 t2s-file tsin-1.src tsin-gtabidx* tsin-ch-idx

=== debian/changelog ===
gcin (2.8.2+dfsg1-1) unstable; urgency=medium

  * Repack upstream tarball to fix source-contains-unsafe-symlink
  * debian/rules:
    * Preserve timestamp of data/Makefile when packing DFSG free source
      tarball.
    * Change +dfsg to +dfsg1 for repacking DFSG source tarball to fix
      source-contains-unsafe-symlink
  * Add manpage for ts-edit-en and ts-contribute-en

 -- ChangZhuo Chen (陳昌倬) <czchen@gmail.com>  Thu, 17 Apr 2014 18:20:35 +0800

gcin (2.8.2+dfsg-2) unstable; urgency=medium

  * Add hardening options
  * Fix FTBFS on mips, powerpc, s390x (Closes: #744296)
  * Enhance get-orig-source:
    * Remove unused symbolic link inside upstream tarball
    * Add debian/README.source

 -- ChangZhuo Chen (陳昌倬) <czchen@gmail.com>  Wed, 16 Apr 2014 18:40:47 +0800

gcin (2.8.2+dfsg-1) unstable; urgency=medium

  [ Yao Wei (魏銘廷) ]
  * New upstream release.
  * update watch url again.
  * add dfsg-free repackaging script
  * multiarch libraries for GTK+2 and GTK+3, closes: #693052
  * update debian helper compat to 9
  * debian/patches: fix sparc build error

  [ ChangZhuo Chen (陳昌倬) ]
  * Update debian/watch
  * Fix debian/rules
  * Add ChangZhuo Chen (陳昌倬) as uploader
  * Install /etc/X11/xinit/xinput.d/gcin in gcin package
  * Fix FTBFS on kfreebsd-*
    Thanks to Yao Wei (魏銘廷)

 -- ChangZhuo Chen (陳昌倬) <czchen@gmail.com>  Sat, 12 Apr 2014 11:24:29 +0800

gcin (2.8.1+dfsg-1) unstable; urgency=low

  * Imported Upstream version 2.8.1+dfsg
  * debian/patches:
    * add patch to pass LDFLAGS for hardening
    * add keyword entry to gcin-tools.desktop
    * add manpage for txt2gtab-phrases
  * debian/gcin.svg:
    replace non-rectangle gcin.png, warned by lintian, with rectangle vector
    icon
  * debian/rules: add hardening options
  * Remove gcin-chewing because it is not supported and is commented out
    in the upstream build scripts.

 -- Yao Wei (魏銘廷) <mwei@lxde.org>  Fri, 02 Aug 2013 21:41:35 +0800

=== debian/control ===
Source: gcin
Section: utils
Priority: optional
Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
Uploaders: Yao Wei (魏銘廷) <mwei@lxde.org>,
           ChangZhuo Chen (陳昌倬) <czchen@gmail.com>
Homepage: http://hyperrate.com/dir.php?eid=67
Build-Depends: debhelper (>= 9.0.0), libgtk2.0-dev (>= 2.20.0), libgtk-3-dev,
 libqt4-dev, libxtst-dev, libanthy-dev, autotools-dev,
 dpkg-dev (>= 1.16.1~)
Standards-Version: 3.9.5
Vcs-Git: git://anonscm.debian.org/pkg-ime/gcin.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ime/gcin.git;a=summary

Package: gcin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gcin-data, gcin-tables
Recommends: im-config, gcin-gtk3-immodule
Suggests: gcin-anthy, gcin-qt4-immodule
Description: GTK+ based input method for Chinese users
 gcin is a GTK+ based input method which focused mainly on Traditional
 Chinese. However, it is also very useful for Simplified Chinese, Japanese,
 and many other languages.
 .
 This package contains only GTK2 immodule. For GTK3 and Qt4 immodule, 
 please install correspondence packages.

Package: gcin-data
Architecture: all
Depends: ${misc:Depends}
Replaces: gcin (<< 2.7.2+dfsg-1)
Breaks: gcin (<< 2.7.2+dfsg-1)
Description: icons and scripts for gcin
 gcin is a GTK+ based input method which focused mainly on Traditional
 Chinese. However, it is also very useful for Simplified Chinese, Japanese,
 and many other languages.
 .
 This package contains icons, scripts and other architecture-independent
 things.

Package: gcin-tables
Architecture: any
Depends: ${misc:Depends}
Replaces: gcin (<< 2.7.2+dfsg-1)
Breaks: gcin (<< 2.7.2+dfsg-1)
Description: input method tables for gcin
 gcin is a GTK+ based input method which focused mainly on Traditional
 Chinese. However, it is also very useful for Simplified Chinese, Japanese,
 and many other languages.
 .
 This package contains architecture-dependent input method tables.

Package: gcin-dev
Section: devel
Architecture: all
Depends: ${misc:Depends}, gcin (>= ${source:Version})
Description: GTK+ based input method platform - development files
 gcin is a GTK+ based input method which focused mainly on Traditional
 Chinese. However, it is also very useful for Simplified Chinese, Japanese,
 and many other languages.
 .
 This package provides header files of gcin.

Package: gcin-gtk3-immodule
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gcin (>= ${source:Version})
Description: GTK3 input method module with gcin as backend
 gcin is a GTK+ based input method which focused mainly on Traditional
 Chinese. However, it is also very useful for Simplified Chinese, Japanese,
 and many other languages.
 .
 This package is the GTK3 input method module (immodule) for gcin.

Package: gcin-qt4-immodule
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gcin (>= ${source:Version})
Description: Qt4 input method module with gcin as backend
 gcin is a GTK+ based input method which focused mainly on Traditional
 Chinese. However, it is also very useful for Simplified Chinese, Japanese,
 and many other languages.
 .
 This package is the Qt4 input method module (immodule) for gcin.

Package: gcin-anthy
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gcin (>= ${source:Version}), 
 anthy
Replaces: gcin (<< 2.7.2+dfsg-1)
Breaks: gcin (<< 2.7.2+dfsg-1)
Description: support library to use Anthy in gcin
 gcin is a GTK+ based input method which focused mainly on Traditional
 Chinese. However, it is also very useful for Simplified Chinese, Japanese,
 and many other languages.
 .
 This package is the support library to use anthy in gcin.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

GTK2VER := $(shell pkg-config --variable=gtk_binary_version gtk+-2.0)
GTK3VER := $(shell pkg-config --variable=gtk_binary_version gtk+-3.0)
DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

PKD   = $(abspath $(dir $(MAKEFILE_LIST)))
PKG   = $(word 2,$(shell dpkg-parsechangelog -l$(PKD)/changelog | grep ^Source))
UVER  = $(shell dpkg-parsechangelog -l$(PKD)/changelog | perl -ne 'print $$1 if m{^Version:\s+(?:\d+:)?(\d.*)(?:\-\d+.*)};')
DTYPE = +dfsg1
VER  ?= $(subst $(DTYPE),,$(UVER))

## http://wiki.debian.org/onlyjob/get-orig-source
.PHONY: get-orig-source
%:
	dh $@

get-orig-source: $(PKG)_$(VER)$(DTYPE).orig.tar.xz $(info I: $(PKG)_$(VER)$(DTYPE))
	@

$(PKG)_$(VER)$(DTYPE).orig.tar.xz:
	@echo "# Downloading..."
	uscan --noconf --verbose --rename --destdir=$(CURDIR) --check-dirname-level=0 --force-download --download-version $(VER) $(PKD)
	$(if $(wildcard $(PKG)-$(VER)),$(error $(PKG)-$(VER) exist, aborting..))
	@echo "# Extracting..."
	mkdir $(PKG)-$(VER) \
	&& tar -xf $(PKG)_$(VER).orig.tar.* --directory $(PKG)-$(VER) --strip-components 1 \
	|| $(RM) -r $(PKG)-$(VER)
	@echo "# Cleaning-up..."
	cd $(PKG)-$(VER) \
	&& $(RM) data/dayi3.cin \
	&& cp --preserve=all data/Makefile data/Makefile.orig \
	&& sed -i "s/dayi3.gtab //" data/Makefile \
	&& touch --reference=data/Makefile.orig data/Makefile \
	&& $(RM) data/Makefile.orig \
	&& $(RM) gcin-*.tar.xz
	@echo "# Packing..."
	find -L "$(PKG)-$(VER)" -xdev -type f -print | sort \
	| XZ_OPT="-6v" tar -caf "$(PKG)_$(VER)$(DTYPE).orig.tar.xz" --owner=root --group=root --mode=a+rX "$(PKG)-$(VER)"\
	&& $(RM) -r "$(PKG)-$(VER)"

override_dh_auto_clean:
	make clean

override_dh_auto_install:
	make install DESTDIR=$(CURDIR)/debian/tmp

	# move libraries to the correspond gtk version
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/gtk-2.0/$(GTK2VER)
	mv debian/tmp/usr/lib/gtk-2.0/immodules debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/gtk-2.0/$(GTK2VER)/
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/gtk-3.0/$(GTK3VER)
	mv debian/tmp/usr/lib/gtk-3.0/immodules debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/gtk-3.0/$(GTK3VER)/

	# workaround to move arch-dep tables to /usr/lib
	mv debian/tmp/usr/share/gcin/table debian/tmp/usr/lib/gcin/
	ln -s /usr/lib/gcin/table debian/tmp/usr/share/gcin/table

override_dh_installchangelogs:
	dh_installchangelogs Changelog.html

override_dh_makeshlibs:
	dh_makeshlibs -n

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg\d*// \
http://hyperrate.com/gcin-source/ gcin-(.*)\.tar\.xz

## gcin 2.8.3+dfsg1

=== Makefile ===
--- 
+++ 
@@ -106,6 +106,7 @@
 	if [ $(GTK3_IM) = 'Y' ]; then $(MAKE) -C gtk3-im; fi
 	if [ $(QT_IM) = 'Y' ]; then $(MAKE) -C qt-im; fi
 	if [ $(QT4_IM) = 'Y' ]; then $(MAKE) -C qt4-im; fi
+	if [ $(QT5_IM) = 'Y' ]; then $(MAKE) -C qt5-im; fi
 
 #gcc_ld_run_path=-Wl,-rpath,$(gcin_ld_run_path)
 
@@ -227,6 +228,7 @@
 	if [ $(GTK3_IM) = 'Y' ]; then $(MAKE) -C gtk3-im install; fi
 	if [ $(QT_IM) = 'Y' ]; then $(MAKE) -C qt-im install; fi
 	if [ $(QT4_IM) = 'Y' ]; then $(MAKE) -C qt4-im install; fi
+	if [ $(QT5_IM) = 'Y' ]; then $(MAKE) -C qt5-im install; fi
 	if [ $(prefix) = /usr/local ]; then \
 	   install -m 644 gcin.png /usr/share/icons/hicolor/64x64/apps; \
 	   install -d $(DOC_DIR); \
@@ -259,6 +261,7 @@
 	if [ $(GTK3_IM) = 'Y' ]; then $(MAKE) -C gtk3-im clean; fi
 	$(MAKE) -C qt-im clean
 	$(MAKE) -C qt4-im clean
+	$(MAKE) -C qt5-im clean
 	$(MAKE) -C menu clean
 	$(MAKE) -C po clean
 	rm -fr *.o *.E *.db *.pico *.so config.mak tags $(PROGS) gcin-nocur $(PROGS_CV) \

=== qt5-im/Makefile ===
include ../config.mak
QT=qt5
QTIM=$(QT)/plugins/platforminputcontexts
IMMODULES=$(libdir)/$(DEB_BUILD_MULTIARCH)/$(QTIM)

INCS=-I../im-client -I/usr/include/X11 `pkg-config Qt5Core Qt5Gui Qt5PlatformSupport QtDBus --cflags`
# dirty fix for ubuntu 14.04,  pkg-config Qt5Gui --cflags return -I/usr/include/qt5/QtGui, missing 5.2.1/QtGui
INCS+=-I /usr/include/qt5/QtGui/5.2.1/QtGui

CXXFLAGS=$(OPTFLAGS) $(INCS) -Wall -D_REENTRANT -DUNIX=1 -fPIC  -DQT5 -DQT_SHARED -DQT_IMMODULE -DPIC -DDEBUG="0$(GCIN_DEBUG)"
OBJS= moc_gcin-qt5.o gcin-qt5.o gcin-imcontext-qt5.o moc_qgcinplatforminputcontext.o
.SUFFIXES:	.c .cpp .a .so .E .h
LDFLAGS=-L../im-client -lgcin-im-client `pkg-config Qt5Core Qt5Gui Qt5PlatformSupport --libs`

GCIN_QT5 = libgcinplatforminputcontextplugin.so

all:    $(GCIN_QT5)

.cpp.E:
	$(CXX) -E $(CFLAGS) $(INCS) $< > $@

moc_gcin-qt5.cpp:	gcin-qt5.h
	$(QT5_MOC) $< -o $@

moc_qgcinplatforminputcontext.cpp:	qgcinplatforminputcontext.h
	$(QT5_MOC) $< -o $@

$(GCIN_QT5): $(OBJS)
	export LD_RUN_PATH=$(gcinlibdir) ;\
	$(CXX) $(gcc_ld_run_path) -fno-exceptions -shared -o $@ $(OBJS) $(LDFLAGS)
	rm -f core.*
install:
	if [ $(prefix) = /usr/local ]; then \
		install -d $(DESTDIR)/$(QT5_IM_DIR); \
		install -m 755 $(GCIN_QT5) $(DESTDIR)/$(QT5_IM_DIR); \
	else \
		install -d $(IMMODULES); \
                install -m 755 $(GCIN_QT5) $(IMMODULES); \
	fi
clean:
	rm -f $(OBJS) $(GCIN_QT5) *~ core.* *moc*.cpp *.E .depend

.depend:
	$(CXX) $(CXXFLAGS) -MM *.cpp > $@

include .depend

=== debian/changelog ===
gcin (2.8.3+dfsg1-6) unstable; urgency=medium

  * Add Breaks, Replaces for gcin-gtk2-immodule Multi-Arch transition.

 -- ChangZhuo Chen (陳昌倬) <czchen@gmail.com>  Tue, 09 Jun 2015 20:15:48 +0800

gcin (2.8.3+dfsg1-5) unstable; urgency=medium

  * Fix maintainer script typos

 -- ChangZhuo Chen (陳昌倬) <czchen@gmail.com>  Fri, 05 Jun 2015 22:12:55 +0800

gcin (2.8.3+dfsg1-4) unstable; urgency=medium

  * Fix gcin-gtk2-immodule, gcin-gtk3-immodule uninstallation error.

 -- ChangZhuo Chen (陳昌倬) <czchen@gmail.com>  Fri, 05 Jun 2015 12:52:21 +0800

gcin (2.8.3+dfsg1-3) unstable; urgency=medium

  * Fix gcin-gtk2-immodule, gcin-gtk3-immodule installation error.

 -- ChangZhuo Chen (陳昌倬) <czchen@gmail.com>  Thu, 04 Jun 2015 13:19:33 +0800

gcin (2.8.3+dfsg1-2) unstable; urgency=medium

  * Merge back to unstable
  * Remove __DATE__ for reproducible build
  * Install manpage for man/txt2gtab-phrase.1

 -- ChangZhuo Chen (陳昌倬) <czchen@gmail.com>  Wed, 03 Jun 2015 18:29:26 +0800

gcin (2.8.3+dfsg1-1) experimental; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 3.9.6
  * Support Multi-Arch
    * Add libgcin, gcin-gtk2-immodule
    * Add postinst, postrm scripts for GTK modules
  * Add debian/gbp.conf
  * debian/control
    * Update Build-Depends for Qt5
    * Add libappindicator3-dev as Build-Depends
    * Add gcin-qt5-immodule
  * debian/copyright
    * Add ChangZhuo Chen (陳昌倬)
    * Use Files-Excluded to exclude non-free part
    * Remove invalid file path
  * debian/rules
    * Remove get-orig-source
    * Use --fail-missing in dh_install

 -- ChangZhuo Chen (陳昌倬) <czchen@gmail.com>  Thu, 22 Jan 2015 22:49:28 +0800

=== debian/control ===
Source: gcin
Section: utils
Priority: optional
Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
Uploaders: Yao Wei (魏銘廷) <mwei@lxde.org>,
           ChangZhuo Chen (陳昌倬) <czchen@gmail.com>,
Homepage: http://hyperrate.com/dir.php?eid=67
Build-Depends: debhelper (>= 9),
               autotools-dev,
               dpkg-dev (>= 1.16.1~),
               libanthy-dev,
               libappindicator3-dev,
               libgtk2.0-dev (>= 2.20.0),
               libgtk-3-dev,
               libqt4-dev,
               libxtst-dev,
               qtbase5-private-dev,
               qtchooser,
Standards-Version: 3.9.6
Vcs-Git: git://anonscm.debian.org/pkg-ime/gcin.git
Vcs-Browser: http://anonscm.debian.org/cgit/pkg-ime/gcin.git

Package: gcin
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends},
         gcin-data,
         gcin-tables,
         libgcin,
Recommends: im-config,
            gcin-gtk2-immodule,
            gcin-gtk3-immodule,
Suggests: gcin-anthy,
          gcin-qt4-immodule,
          gcin-qt5-immodule,
          gcin-voice,
Description: GTK+ based input method for Chinese users
 gcin is a GTK+ based input method which focused mainly on Traditional
 Chinese. However, it is also very useful for Simplified Chinese, Japanese,
 and many other languages.
 .
 To use gcin, the correspondence immodule packages also need to be installed.
 They are:
 .
  * gcin-gtk2-immodule for GTK2
  * gcin-gtk3-immodule for GTK3
  * gcin-qt4-immodule for Qt4
  * gcin-qt5-immodule for Qt5

Package: gcin-data
Architecture: all
Depends: ${misc:Depends},
Replaces: gcin (<< 2.7.2+dfsg-1)
Breaks: gcin (<< 2.7.2+dfsg-1)
Description: icons and scripts for gcin
 gcin is a GTK+ based input method which focused mainly on Traditional
 Chinese. However, it is also very useful for Simplified Chinese, Japanese,
 and many other languages.
 .
 This package contains icons, scripts and other architecture-independent
 things.

Package: gcin-tables
Architecture: any
Depends: ${misc:Depends},
Replaces: gcin (<< 2.7.2+dfsg-1)
Breaks: gcin (<< 2.7.2+dfsg-1)
Description: input method tables for gcin
 gcin is a GTK+ based input method which focused mainly on Traditional
 Chinese. However, it is also very useful for Simplified Chinese, Japanese,
 and many other languages.
 .
 This package contains architecture-dependent input method tables.

Package: libgcin
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: library for gcin
 gcin is a GTK+ based input method which focused mainly on Traditional
 Chinese. However, it is also very useful for Simplified Chinese, Japanese,
 and many other languages.
 .
 This package contains library for gcin.

Package: gcin-dev
Section: devel
Architecture: all
Depends: ${misc:Depends},
         gcin (>= ${source:Version}),
Description: GTK+ based input method platform - development files
 gcin is a GTK+ based input method which focused mainly on Traditional
 Chinese. However, it is also very useful for Simplified Chinese, Japanese,
 and many other languages.
 .
 This package provides header files of gcin.

Package: gcin-gtk2-immodule
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         gcin (>= ${source:Version}),
Breaks: gcin (<< 2.8.3+dfsg1-1)
Replaces: gcin (<< 2.8.3+dfsg1-1)
Description: GTK2 input method module with gcin as backend
 gcin is a GTK+ based input method which focused mainly on Traditional
 Chinese. However, it is also very useful for Simplified Chinese, Japanese,
 and many other languages.
 .
 This package is the GTK2 input method module (immodule) for gcin.

Package: gcin-gtk3-immodule
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         gcin (>= ${source:Version}),
Description: GTK3 input method module with gcin as backend
 gcin is a GTK+ based input method which focused mainly on Traditional
 Chinese. However, it is also very useful for Simplified Chinese, Japanese,
 and many other languages.
 .
 This package is the GTK3 input method module (immodule) for gcin.

Package: gcin-qt4-immodule
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         gcin (>= ${source:Version}),
Description: Qt4 input method module with gcin as backend
 gcin is a GTK+ based input method which focused mainly on Traditional
 Chinese. However, it is also very useful for Simplified Chinese, Japanese,
 and many other languages.
 .
 This package is the Qt4 input method module (immodule) for gcin.

Package: gcin-qt5-immodule
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         gcin (>= ${source:Version}),
Description: Qt5 input method module with gcin as backend
 gcin is a GTK+ based input method which focused mainly on Traditional
 Chinese. However, it is also very useful for Simplified Chinese, Japanese,
 and many other languages.
 .
 This package is the Qt5 input method module (immodule) for gcin.

Package: gcin-anthy
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         gcin (>= ${source:Version}),
         anthy,
Replaces: gcin (<< 2.7.2+dfsg-1)
Breaks: gcin (<< 2.7.2+dfsg-1)
Description: support library to use Anthy in gcin
 gcin is a GTK+ based input method which focused mainly on Traditional
 Chinese. However, it is also very useful for Simplified Chinese, Japanese,
 and many other languages.
 .
 This package is the support library to use anthy in gcin.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

GTK2VER := $(shell pkg-config --variable=gtk_binary_version gtk+-2.0)
GTK3VER := $(shell pkg-config --variable=gtk_binary_version gtk+-3.0)
GTK2_IMMODULES := $(shell pkg-config --variable=libdir gtk+-2.0)/libgtk2.0-0/gtk-query-immodules-2.0
GTK3_IMMODULES := $(shell pkg-config --variable=libdir gtk+-3.0)/libgtk-3-0/gtk-query-immodules-3.0

%:
	dh $@

override_dh_auto_clean:
	make clean

override_dh_auto_configure:
	dh_auto_configure -- --gcinlibdir=/usr/lib/$(DEB_HOST_MULTIARCH)/gcin

	sed 's,%%GTK_QUERY_IMMODULES%%,$(GTK2_IMMODULES),g' $(CURDIR)/debian/gcin-gtk-immodule.postinst.in > $(CURDIR)/debian/gcin-gtk2-immodule.postinst
	sed 's,%%GTK_QUERY_IMMODULES%%,$(GTK2_IMMODULES),g' $(CURDIR)/debian/gcin-gtk-immodule.postrm.in > $(CURDIR)/debian/gcin-gtk2-immodule.postrm
	sed 's,%%GTK_QUERY_IMMODULES%%,$(GTK3_IMMODULES),g' $(CURDIR)/debian/gcin-gtk-immodule.postinst.in > $(CURDIR)/debian/gcin-gtk3-immodule.postinst
	sed 's,%%GTK_QUERY_IMMODULES%%,$(GTK3_IMMODULES),g' $(CURDIR)/debian/gcin-gtk-immodule.postrm.in > $(CURDIR)/debian/gcin-gtk3-immodule.postrm

override_dh_auto_install:
	make install DESTDIR=$(CURDIR)/debian/tmp

	# move libraries to the correspond gtk version
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/gtk-2.0/$(GTK2VER)
	mv debian/tmp/usr/lib/gtk-2.0/immodules debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/gtk-2.0/$(GTK2VER)/
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/gtk-3.0/$(GTK3VER)
	mv debian/tmp/usr/lib/gtk-3.0/immodules debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/gtk-3.0/$(GTK3VER)/

	# workaround to move arch-dep tables to /usr/lib
	mv debian/tmp/usr/share/gcin/table debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/gcin/table
	ln -s /usr/lib/$(DEB_HOST_MULTIARCH)/gcin/table debian/tmp/usr/share/gcin/table

override_dh_install:
	dh_install --fail-missing \
		--exclude=Changelog.html \
		--exclude=README.html \
		--exclude=gcin.png \
		$(NULL)

override_dh_installchangelogs:
	dh_installchangelogs Changelog.html

override_dh_makeshlibs:
	dh_makeshlibs -n

## gcin 2.8.4%2Bdfsg1

=== qt5-im/Makefile ===
--- 
+++ 
@@ -5,7 +5,9 @@
 
 INCS=-I../im-client -I/usr/include/X11 `pkg-config Qt5Core Qt5Gui Qt5PlatformSupport QtDBus --cflags`
 # dirty fix for ubuntu 14.04,  pkg-config Qt5Gui --cflags return -I/usr/include/qt5/QtGui, missing 5.2.1/QtGui
-INCS+=-I /usr/include/qt5/QtGui/5.2.1/QtGui
+MODVERSION=`pkg-config --modversion Qt5Gui`
+INCS+=-I/usr/include/qt5/QtGui/$(MODVERSION)/QtGui -I/usr/include/i386-linux-gnu/qt5/QtGui/$(MODVERSION)/QtGui -I/usr/include/x86_64-linux-gnu/qt5/QtGui/$(MODVERSION)/QtGui
+INCS+=-I/usr/include/x86_64-linux-gnu/qt5/QtGui/$(MODVERSION)/QtGui
 
 CXXFLAGS=$(OPTFLAGS) $(INCS) -Wall -D_REENTRANT -DUNIX=1 -fPIC  -DQT5 -DQT_SHARED -DQT_IMMODULE -DPIC -DDEBUG="0$(GCIN_DEBUG)"
 OBJS= moc_gcin-qt5.o gcin-qt5.o gcin-imcontext-qt5.o moc_qgcinplatforminputcontext.o

## gcin 2.8.4+dfsg1

=== Makefile ===
--- 
+++ 
@@ -50,10 +50,10 @@
 OBJS_pin_juyin = pin-juyin.o util.o pho-lookup.o locale.o pho-sym.o
 
 OBJS_tsin2gtab_phrase = tsin2gtab-phrase.o gcin-conf.o util.o locale.o \
-	pho-dbg.o pho-sym.o gtab-dbg.o lang.o
+	pho-dbg.o pho-sym.o gtab-dbg.o lang.o gcin-settings.o
 
 OBJS_txt2gtab_phrase = txt2gtab-phrase.o gcin-conf.o util.o locale.o \
-	pho-dbg.o pho-sym.o gtab-dbg.o lang.o
+	pho-dbg.o pho-sym.o gtab-dbg.o lang.o gcin-settings.o
 
 #WALL=-Wall

=== gtk3-im/Makefile ===
include ../config.mak

OBJS = imgcin.o gtkimcontextgcin.o
GTK3IM=gtk-3.0/immodules
GTKINC=`pkg-config --cflags gtk+-3.0`
LDFLAGS=`pkg-config --libs gtk+-3.0`
LDFLAGS+='-Wl,--as-needed'
IMMODULES=$(libdir)/$(GTK3IM)
IMMODULES_LOCAL=/usr/$(LIB)/$(GTK3IM)


ifeq ($(MAC_OS),1)
EXTRA_INC=-I/sw/include
endif

.SUFFIXES:	.c .o .E
CFLAGS = $(OPTFLAGS) $(EXTRA_INC) $(GTKINC) -I../im-client -I.. -DUNIX=1 \
-I../IMdkit/include -DCLIENT_LIB=1 -DMAC_OS=$(MAC_OS) -DFREEBSD=$(FREEBSD)

.c.o:
	$(CC) -c -fPIC $(CFLAGS) -o $@ $<

.c.E:
	$(CC) -E $(CFLAGS) -o $@ $<

all:	im-gcin.so im-gcin-cur.so

im-gcin.so:     $(OBJS) ../im-client/libgcin-im-client.so
	$(CC) $(gcc_ld_run_path) $(SO_FLAGS) $(OBJS) -L../im-client -lgcin-im-client -o $@ $(LDFLAGS)
	rm -f core.*

im-gcin-cur.so:     $(OBJS) ../im-client/libgcin-im-client.so
	$(CC) $(SO_FLAGS) $(OBJS) -L../im-client -lgcin-im-client -o $@ $(LDFLAGS)
	rm -f core.*

clean:
	rm -f *.o *.so *~ core.* .depend *.E

install:
	if [ $(prefix) = /usr/local ]; then \
		install -d $(IMMODULES_LOCAL); \
		install -m 755 im-gcin.so $(IMMODULES_LOCAL); \
		gtk-query-immodules-3.0$(GTK_QUERY_IM_64) --update-cache; \
	else \
		install -d $(IMMODULES); \
		install -m 755 im-gcin.so $(IMMODULES); \
	fi

.depend:
	$(CC) $(CFLAGS) -MM *.c > $@

include .depend

=== po/Makefile ===
include ../config.mak

all:	gmo

gmo:
	$(MAKE) -C en_US
	$(MAKE) -C zh_CN

pot:
	xgettext --from-code=UTF-8 --keyword=_ --keyword=N_ --keyword=_L -o ./gcin.pot ../*.c* ../*/*.c ../*/*.cpp

install:
	install -d $(datadir)/locale/en_US/LC_MESSAGES
	install -d $(datadir)/locale/zh_CN/LC_MESSAGES
	install -m 644 en_US/gcin.gmo $(datadir)/locale/en_US/LC_MESSAGES/gcin.mo
	install -m 644 zh_CN/gcin.gmo $(datadir)/locale/zh_CN/LC_MESSAGES/gcin.mo

clean:
	$(MAKE) -C en_US clean
	$(MAKE) -C zh_CN clean
	rm -f ./gcin.pot

=== debian/changelog ===
gcin (2.8.4+dfsg1-1ubuntu1.1) xenial-proposed; urgency=medium

  * fix_get_gcin_xim_name.patch: Fix gnome-terminal-server crash issue.
    (LP: #1617505) 

 -- Su, Jun-Ming <sujunmin@gmail.com>  Sun, 28 Aug 2016 14:27:46 +0800

gcin (2.8.4+dfsg1-1ubuntu1) xenial; urgency=medium

  * Rebuild against Qt 5.5.1.
  * Remove the forced 'make clean' to be able to build a source package.

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Wed, 02 Dec 2015 12:00:41 +0200

gcin (2.8.4+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Remove gcin-dev since libgcin-im-client.so is not designed to be used
    outside gcin.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Thu, 15 Oct 2015 16:02:15 +0800

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: gcin
 Section: utils
 Priority: optional
-Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
 Uploaders: Yao Wei (魏銘廷) <mwei@lxde.org>,
-           ChangZhuo Chen (陳昌倬) <czchen@gmail.com>,
+           ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
 Homepage: http://hyperrate.com/dir.php?eid=67
 Build-Depends: debhelper (>= 9),
                autotools-dev,
@@ -85,18 +86,6 @@
  .
  This package contains library for gcin.
 
-Package: gcin-dev
-Section: devel
-Architecture: all
-Depends: ${misc:Depends},
-         gcin (>= ${source:Version}),
-Description: GTK+ based input method platform - development files
- gcin is a GTK+ based input method which focused mainly on Traditional
- Chinese. However, it is also very useful for Simplified Chinese, Japanese,
- and many other languages.
- .
- This package provides header files of gcin.
-
 Package: gcin-gtk2-immodule
 Architecture: any
 Multi-Arch: same

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg\d*//,repacksuffix=+dfsg1 \
http://hyperrate.com/gcin-source/ gcin-(.*)\.tar\.xz

## gcin 2.8.5+dfsg1

=== Makefile ===
--- 
+++ 
@@ -31,8 +31,8 @@
 OBJS_sim2trad=sim2trad.o util.o gcin2.so locale.o gcin-conf.o gcin-icon.o
 OBJS_phod2a=phod2a.o pho-util.o gcin-conf.o pho-sym.o table-update.o pho-dbg.o locale.o \
              gcin-settings.o util.o
-OBJS_tsa2d32=tsa2d32.o gcin-send.o util.o pho-sym.o gcin-conf.o locale.o pho-lookup.o \
-pinyin.o pho2pinyin.o pho-dbg.o gcin-settings.o lang.o
+OBJS_tsa2d32=tsa2d32.o gcin-send.o util.o pho-sym.o gcin-conf.o locale.o pho-lookup.o pinyin.o pho2pinyin.o pho-dbg.o gcin-settings.o lang.o
+OBJS_gtab_db_gen=gtab-db-gen.o gcin-send.o util.o pho-sym.o gcin-conf.o locale.o pho-lookup.o pinyin.o pho2pinyin.o pho-dbg.o gcin-settings.o lang.o
 OBJS_phoa2d=phoa2d.o pho-sym.o gcin-send.o gcin-conf.o locale.o pho-lookup.o util.o pho-dbg.o
 OBJS_kbmcv=kbmcv.o pho-sym.o util.o locale.o
 OBJS_tsd2a32=tsd2a32.o pho-sym.o pho-dbg.o locale.o util.o gtab-dbg.o pho2pinyin.o \
@@ -82,10 +82,12 @@
 OBJS += gcb.o
 endif
 
+GCIN_LDFLAGS = $(LDFLAGS)
+
 ifeq ($(USE_INDICATOR),Y)
 CFLAGS += -DUSE_INDICATOR=1 $(INDICATOR_INC)
 OBJS += tray-indicator.o
-LDFLAGS += $(INDICATOR_LIB)
+#GCIN_LDFLAGS += $(INDICATOR_LIB)
 endif
 
 OBJ_IMSRV=im-addr.o im-dispatch.o im-srv.o gcin-crypt.o
@@ -93,7 +95,7 @@
 PROGS=gcin tsd2a32 tsa2d32 phoa2d phod2a tslearn gcin-tools gcin2tab \
 	juyin-learn sim2trad gcin-gb-toggle gcin-message gtab-merge \
 	gcin-kbm-toggle tsin2gtab-phrase gcin-exit ts-edit ts-contribute \
-	txt2gtab-phrase
+	txt2gtab-phrase gtab-db-gen
 PROGS_SYM=trad2sim
 PROGS_CV=kbmcv pin-juyin
 
@@ -111,7 +113,7 @@
 #gcc_ld_run_path=-Wl,-rpath,$(gcin_ld_run_path)
 
 gcin:   $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV)
-	$(CCLD) $(EXTRA_LDFLAGS) $(gcc_ld_run_path) -o $@ $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV) -lXtst $(LDFLAGS) -L/usr/X11R6/$(LIB)
+	$(CCLD) $(EXTRA_LDFLAGS) $(gcc_ld_run_path) -o $@ $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV) -lXtst $(GCIN_LDFLAGS) -L/usr/X11R6/$(LIB)
 	rm -f core.* vgcore.*
 	ln -sf $@ $@.test
 
@@ -150,8 +152,11 @@
 tsa2d32:  $(OBJS_tsa2d32) im-client/libgcin-im-client.so
 	$(CCLD) $(gcc_ld_run_path) -o $@ $(OBJS_tsa2d32) -L./im-client -lgcin-im-client $(LDFLAGS)
 
-tsd2a:  $(OBJS_tsd2a)
-	$(CCLD) -o $@ $(OBJS_tsd2a) $(LDFLAGS)
+gtab-db-gen:  $(OBJS_gtab_db_gen) im-client/libgcin-im-client.so
+	$(CCLD) $(gcc_ld_run_path) -o $@ $(OBJS_gtab_db_gen) -L./im-client -lgcin-im-client $(LDFLAGS)
+
+#tsd2a:  $(OBJS_tsd2a)
+#	$(CCLD) -o $@ $(OBJS_tsd2a) $(LDFLAGS)
 
 tsd2a32:  $(OBJS_tsd2a32)
 	$(CCLD) -o $@ $(OBJS_tsd2a32) $(LDFLAGS)

=== debian/changelog ===
gcin (2.8.5+dfsg1-4build4) bionic; urgency=medium

  * No-change rebuild against qtbase-abi-5-9-5.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sat, 14 Apr 2018 21:59:11 -0500

gcin (2.8.5+dfsg1-4build3) bionic; urgency=medium

  * No-change rebuild against qtbase-abi-5-9-4.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Tue, 27 Feb 2018 09:48:02 -0600

gcin (2.8.5+dfsg1-4build2) bionic; urgency=medium

  * Rebuild against new libanthy1.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 20 Nov 2017 07:51:32 +0100

gcin (2.8.5+dfsg1-4build1) bionic; urgency=medium

  * No-change rebuild against qtbase5-private-dev.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Fri, 03 Nov 2017 17:15:25 -0500

gcin (2.8.5+dfsg1-4) unstable; urgency=medium

  * Bump Standards-Version to 4.1.0.
  * Remove gcin-qt4-immodule (Closes: #874886).
  * Remove unnecessary Build-Depends autotools-dev because of compat 10.
  * Add Multi-Arch: same to gcin-anthy.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 24 Sep 2017 17:43:10 +0800

gcin (2.8.5+dfsg1-3) unstable; urgency=medium

  [ Adrian Bunk ]
  * Workaround for broken dependencies in Makefiles (Closes: #867781).

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 09 Jul 2017 20:31:25 +0800

gcin (2.8.5+dfsg1-2) unstable; urgency=medium

  [ Dmitry Shachnev ]
  * Fix build with Qt 5.9 (Closes: #867573).

  [ ChangZhuo Chen (陳昌倬) ]
  * Bump Standards-Version to 4.0.0.
    * Use https in copyright Format field.
  * Bump compat to 10.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 09 Jul 2017 09:21:29 +0800

gcin (2.8.5+dfsg1-1) unstable; urgency=medium

  * Merge to unstable.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 18 Jun 2017 19:59:02 +0800

gcin (2.8.5+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Drop upstream already applied patch.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 04 Feb 2017 23:55:34 +0800

gcin (2.8.4+dfsg1-11) unstable; urgency=medium

  * Fix Qt5 plugin. (Closes: #844407)

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 03 Dec 2016 02:00:43 +0800

gcin (2.8.4+dfsg1-10) unstable; urgency=medium

  * Avoid the crash in gnome-terminal.

 -- Shih-Yuan Lee (FourDollars) <fourdollars@gmail.com>  Tue, 04 Oct 2016 21:31:54 +0800

gcin (2.8.4+dfsg1-9) unstable; urgency=medium

  * Drop unnecessary override_dh_auto_clean rule.
    Thanks to Jeremy Bicha (Closes: #831526)

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Mon, 18 Jul 2016 19:18:27 +0800

gcin (2.8.4+dfsg1-8) unstable; urgency=medium

  * Fix buggy version comparison in gcin.postinst.
    Thanks to Andreas Beckmann (Closes: #829149)

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Fri, 01 Jul 2016 11:25:29 +0800

gcin (2.8.4+dfsg1-7) unstable; urgency=medium

  * Use memset to remove randomness for reproducible build.
    Thanks to Chris Lamb (Closes: #828074)

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Thu, 30 Jun 2016 00:19:51 +0800

gcin (2.8.4+dfsg1-6) unstable; urgency=medium

  * Fix accessing uninitialized variable in maintainer script.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Thu, 23 Jun 2016 19:31:57 +0800

gcin (2.8.4+dfsg1-5) unstable; urgency=medium

  * Fix maintainer script error when install. (Closes: #827847)

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Wed, 22 Jun 2016 08:58:12 +0800

gcin (2.8.4+dfsg1-4) unstable; urgency=medium

  * Remove Debian specific menu.
  * Remove alternatives for xinput-*.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Thu, 16 Jun 2016 00:07:10 +0800

gcin (2.8.4+dfsg1-3) unstable; urgency=medium

  * Fix FTBFS on Qt 5.6.1. (Closes: #827262)
  * Bump Standards-Version to 3.9.8.
  * Update Vcs-* fields.
  * Remove im-switch config.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Wed, 15 Jun 2016 22:46:00 +0800

gcin (2.8.4+dfsg1-2) unstable; urgency=medium

  * Update Vcs-* fields
  * Use debhelper >= 9.20151219 for dbgsym.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 20 Dec 2015 21:46:11 +0800

=== debian/control ===
--- 
+++ 
@@ -1,25 +1,23 @@
 Source: gcin
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
+Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
 Uploaders: Yao Wei (魏銘廷) <mwei@lxde.org>,
            ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
+           Shih-Yuan Lee (FourDollars) <fourdollars@gmail.com>,
 Homepage: http://hyperrate.com/dir.php?eid=67
-Build-Depends: debhelper (>= 9),
-               autotools-dev,
+Build-Depends: debhelper (>= 10),
                dpkg-dev (>= 1.16.1~),
                libanthy-dev,
                libappindicator3-dev,
                libgtk2.0-dev (>= 2.20.0),
                libgtk-3-dev,
-               libqt4-dev,
                libxtst-dev,
                qtbase5-private-dev,
                qtchooser,
-Standards-Version: 3.9.6
-Vcs-Git: git://anonscm.debian.org/pkg-ime/gcin.git
-Vcs-Browser: http://anonscm.debian.org/cgit/pkg-ime/gcin.git
+Standards-Version: 4.1.0
+Vcs-Git: https://anonscm.debian.org/git/pkg-ime/gcin.git
+Vcs-Browser: https://anonscm.debian.org/git/pkg-ime/gcin.git
 
 Package: gcin
 Architecture: any
@@ -33,7 +31,6 @@
             gcin-gtk2-immodule,
             gcin-gtk3-immodule,
 Suggests: gcin-anthy,
-          gcin-qt4-immodule,
           gcin-qt5-immodule,
           gcin-voice,
 Description: GTK+ based input method for Chinese users
@@ -46,7 +43,6 @@
  .
   * gcin-gtk2-immodule for GTK2
   * gcin-gtk3-immodule for GTK3
-  * gcin-qt4-immodule for Qt4
   * gcin-qt5-immodule for Qt5
 
 Package: gcin-data
@@ -114,19 +110,6 @@
  .
  This package is the GTK3 input method module (immodule) for gcin.
 
-Package: gcin-qt4-immodule
-Architecture: any
-Multi-Arch: same
-Depends: ${misc:Depends},
-         ${shlibs:Depends},
-         gcin (>= ${source:Version}),
-Description: Qt4 input method module with gcin as backend
- gcin is a GTK+ based input method which focused mainly on Traditional
- Chinese. However, it is also very useful for Simplified Chinese, Japanese,
- and many other languages.
- .
- This package is the Qt4 input method module (immodule) for gcin.
-
 Package: gcin-qt5-immodule
 Architecture: any
 Multi-Arch: same
@@ -142,6 +125,7 @@
 
 Package: gcin-anthy
 Architecture: any
+Multi-Arch: same
 Depends: ${misc:Depends},
          ${shlibs:Depends},
          gcin (>= ${source:Version}),

=== debian/rules ===
--- 
+++ 
@@ -13,10 +13,7 @@
 GTK3_IMMODULES := $(shell pkg-config --variable=libdir gtk+-3.0)/libgtk-3-0/gtk-query-immodules-3.0
 
 %:
-	dh $@
-
-override_dh_auto_clean:
-	make clean
+	dh $@ --no-parallel
 
 override_dh_auto_configure:
 	dh_auto_configure -- --gcinlibdir=/usr/lib/$(DEB_HOST_MULTIARCH)/gcin
